/*
 * blitters.c
 *
 * miscelaneous blitters
 */

/* $Id: blitters.c,v 1.1 1999/01/11 02:22:20 nyef Exp $ */

/*
 * Can't include blitters.h, because I'm cheating horribly and the compiler
 * would find out if I did.
 */
/* #include "blitters.h" */

/* blitter mark 2 */

/*
 * blit(unsigned char pattern0, unsigned char pattern1,
 *     unsigned char count, unsigned char skip,
 *     unsigned char *colors, unsigned char *vbp);
 */

/*
 * setup
 *
 * 8-bit version
 *
 * pushl %esi
 * pushl %edi
 * pushl %ebx
 * pushl %ecx
 * ; pushl %ebp // 16-bit only
 * movb 0x18(%esp), %bl // 14 in 8-bit mode
 * movb 0x1c(%esp), %bh // 18 in 8-bit mode
 * movb 0x24(%esp), %cl // 20 in 8-bit mode
 * shlb %cl, %bl
 * shlb %cl, %bh
 * movl 0x28(%esp), %esi // 24 in 8-bit mode
 * movl 0x2c(%esp), %edi // 28 in 8-bit mode
 * movb 0x20(%esp), %cl // 1c in 8-bit mode
 * ; movl xlatepal, %ebp // 16-bit only. uses private video interface.
 *
 * ; bl: pattern
 * ; bh: pattern
 * ; cl: number of pixels this tile (for clipping)
 * ; ebp: color translation table (16-bit only)
 * ; esi: &colors
 * ; edi: vbp
 *
 * 0:
 * xor %eax, %eax
 * rclb $1, %bl
 * rcll $1, %eax
 * rclb $1, %bh
 * rcll $1, %eax
 * orb %al, %al
 * jz 1f
 * movb (%esi, %eax, 1), %al
 * movb %al, (%edi)
 * 1:
 * incl %edi
 * decb %cl
 * jnz 0b
 * 
 * cleanup
 *
 * ; popl %ebp // 16-bit only
 * popl %ecx
 * popl %ebx
 * popl %edi
 * popl %esi
 * ret
 */

struct blit_2_8 {
    unsigned long pushls1; /* 0x51535756 */
    unsigned long mov1; /* 0x14245c8a */
    unsigned long mov2; /* 0x18247c8a */
    unsigned long mov3; /* 0x20244c8a */
    unsigned short shlb1; /* 0xe3d2 */
    unsigned short shlb2; /* 0xe7d2 */
    unsigned long mov4; /* 0x2424748b */
    unsigned long mov5; /* 0x28247c8b */
    unsigned long mov6; /* 0x1c244c8a */
    /* end of setup */

    unsigned short xor1; /* 0xc031 */
    unsigned short rcl1; /* 0xd3d0 */
    unsigned short rcl2; /* 0xd0d1 */
    unsigned short rcl3; /* 0xd7d0 */
    unsigned short rcl4; /* 0xd0d1 */
    unsigned short or1; /* 0xc008 */
    unsigned short jz1; /* 0x0574 */
    unsigned short mov7; /* 0x048a */
    unsigned char mov7a; /* 0x30 */
    unsigned short mov8; /* 0x0788 */
    unsigned char inc1; /* 0x47 */
    unsigned short dec1; /* 0xc9fe */
    unsigned short jnz; /* 0xe875 */
    /* end of loop */
    
    unsigned long popls1; /* 0x5e5f5b59 */
    unsigned char ret; /* 0xc3 */
} __attribute__ ((packed));

struct blit_2_8 blit_2_8 = {
    0x51535756, 0x14245c8a, 0x18247c8a, 0x20244c8a,
    0xe3d2, 0xe7d2, 0x2424748b, 0x28247c8b,
    0x1c244c8a, 0xc031, 0xd3d0, 0xd0d1, 0xd7d0,
    0xd0d1, 0xc008, 0x0574, 0x048a, 0x30, 0x0788,
    0x47, 0xc9fe, 0xe875, 0x5e5f5b59, 0xc3,
};

struct blit_2_8 blit_2_8_rev = {
    0x51535756, 0x14245c8a, 0x18247c8a, 0x20244c8a,
    0xebd2, 0xefd2, 0x2424748b, 0x28247c8b,
    0x1c244c8a, 0xc031, 0xdbd0, 0xd0d1, 0xdfd0,
    0xd0d1, 0xc008, 0x0574, 0x048a, 0x30, 0x0788,
    0x47, 0xc9fe, 0xe875, 0x5e5f5b59, 0xc3,
};

/*
 * blit(unsigned char pattern0, unsigned char pattern1,
 *      unsigned char pattern2, unsigned char pattern3,
 *      unsigned char count, unsigned char skip,
 *      unsigned char *colors, unsigned char *vbp);
 */

struct blit_4_8 {
    unsigned long pushls1; /* 0x51535756 */
    unsigned char pushl2; /* 0x52 */
    unsigned long mov1; /* 0x18245c8a */
    unsigned long mov2; /* 0x1c247c8a */
    unsigned long mov9; /* 0x2024548a */
    unsigned long mova; /* 0x2424748a */
    unsigned long mov3; /* 0x2c244c8a */
    unsigned short shlb1; /* 0xe3d2 */
    unsigned short shlb2; /* 0xe7d2 */
    unsigned short shlb3; /* 0xe2d2 */
    unsigned short shlb4; /* 0xe6d2 */
    unsigned long mov4; /* 0x3024748b */
    unsigned long mov5; /* 0x34247c8b */
    unsigned long mov6; /* 0x28244c8a */
    /* end of setup */

    unsigned short xor1; /* 0xc031 */
    unsigned short rcl1; /* 0xd3d0 */
    unsigned short rcl2; /* 0xd0d1 */
    unsigned short rcl3; /* 0xd7d0 */
    unsigned short rcl4; /* 0xd0d1 */
    unsigned short rcl5; /* 0xd2d0 */
    unsigned short rcl6; /* 0xd0d1 */
    unsigned short rcl7; /* 0xd6d0 */
    unsigned short rcl8; /* 0xd0d1 */
    unsigned short mov7; /* 0x048a */
    unsigned char mov7a; /* 0x30 */
    unsigned short mov8; /* 0x0788 */
    unsigned char inc1; /* 0x47 */
    unsigned short dec1; /* 0xc9fe */
    unsigned short jnz; /* 0xe475 */
    /* end of loop */

    unsigned char popl2; /* 0x5a */
    unsigned long popls1; /* 0x5e5f5b59 */
    unsigned char ret; /* 0xc3 */
} __attribute__ ((packed));

struct blit_4_8 blit_4_8 = {
    0x51535756, 0x52, 0x18245c8a, 0x1c247c8a, 0x2024548a,
    0x2424748a, 0x2c244c8a, 0xe3d2, 0xe7d2, 0xe2d2, 0xe6d2, 0x3024748b,
    0x34247c8b, 0x28244c8a, 0xc031, 0xd3d0, 0xd0d1,
    0xd7d0, 0xd0d1, 0xd2d0, 0xd0d1, 0xd6d0, 0xd0d1,
    0x048a, 0x30, 0x0788, 0x47, 0xc9fe,
    0xe475, 0x5a, 0x5e5f5b59, 0xc3,
};

struct blit_4_8 blit_4_8_rev = {
    0x51535756, 0x52, 0x18245c8a, 0x1c247c8a, 0x2024548a,
    0x2424748a, 0x2c244c8a, 0xebd2, 0xefd2, 0xead2, 0xeed2, 0x3024748b,
    0x34247c8b, 0x28244c8a, 0xc031, 0xdbd0, 0xd0d1,
    0xdfd0, 0xd0d1, 0xdad0, 0xd0d1, 0xded0, 0xd0d1,
    0x048a, 0x30, 0x0788, 0x47, 0xc9fe,
    0xe475, 0x5a, 0x5e5f5b59, 0xc3,
};

struct blit_4_8_czt {
    unsigned long pushls1; /* 0x51535756 */
    unsigned char pushl2; /* 0x52 */
    unsigned long mov1; /* 0x18245c8a */
    unsigned long mov2; /* 0x1c247c8a */
    unsigned long mov9; /* 0x20244c8a */
    unsigned long mova; /* 0x24246c8a */
    unsigned long mov3; /* 0x2c244c8a */
    unsigned short shlb1; /* 0xe3d2 */
    unsigned short shlb2; /* 0xe7d2 */
    unsigned short shlb3; /* 0xe2d2 */
    unsigned short shlb4; /* 0xe6d2 */
    unsigned long mov4; /* 0x3024748b */
    unsigned long mov5; /* 0x34247c8b */
    unsigned long mov6; /* 0x28244c8a */
    /* end of setup */

    unsigned short xor1; /* 0xc031 */
    unsigned short rcl1; /* 0xd3d0 */
    unsigned short rcl2; /* 0xd0d1 */
    unsigned short rcl3; /* 0xd7d0 */
    unsigned short rcl4; /* 0xd0d1 */
    unsigned short rcl5; /* 0xd2d0 */
    unsigned short rcl6; /* 0xd0d1 */
    unsigned short rcl7; /* 0xd6d0 */
    unsigned short rcl8; /* 0xd0d1 */
    unsigned short or1; /* 0xc008 */
    unsigned short jz1; /* 0x0574 */
    unsigned short mov7; /* 0x048a */
    unsigned char mov7a; /* 0x30 */
    unsigned short mov8; /* 0x0788 */
    unsigned char inc1; /* 0x47 */
    unsigned short dec1; /* 0xc9fe */
    unsigned short jnz; /* 0xe075 */
    /* end of loop */

    unsigned char popl2; /* 0x5a */
    unsigned long popls1; /* 0x5e5f5b59 */
    unsigned char ret; /* 0xc3 */
} __attribute__ ((packed));

struct blit_4_8_czt blit_4_8_czt = {
    0x51535756, 0x52, 0x18245c8a, 0x1c247c8a, 0x20244c8a,
    0x24246c8a, 0x2c244c8a, 0xe3d2, 0xe7d2, 0xe2d2, 0xe6d2, 0x3024748b,
    0x34247c8b, 0x28244c8a, 0xc031, 0xd3d0, 0xd0d1,
    0xd7d0, 0xd0d1, 0xd2d0, 0xd0d1, 0xd6d0, 0xd0d1,
    0xc008, 0x0574, 0x048a, 0x30, 0x0788, 0x47, 0xc9fe,
    0xe075, 0x5a, 0x5e5f5b59, 0xc3,
};

struct blit_4_8_czt blit_4_8_czt_rev = {
    0x51535756, 0x52, 0x18245c8a, 0x1c247c8a, 0x20244c8a,
    0x24246c8a, 0x2c244c8a, 0xebd2, 0xefd2, 0xead2, 0xeed2, 0x3024748b,
    0x34247c8b, 0x28244c8a, 0xc031, 0xdbd0, 0xd0d1,
    0xdfd0, 0xd0d1, 0xdad0, 0xd0d1, 0xddd0, 0xd0d1,
    0xc008, 0x0574, 0x048a, 0x30, 0x0788, 0x47, 0xc9fe,
    0xe075, 0x5a, 0x5e5f5b59, 0xc3,
};

/*
 * $Log: blitters.c,v $
 * Revision 1.1  1999/01/11 02:22:20  nyef
 * Initial revision
 *
 */
