/*
 * io_nes.S
 *
 * NES I/O space emulation
 */

/* $Id: io_pce.S,v 1.6 1998/10/21 00:17:14 nyef Exp $ */

#include "opc6280.h"
	
	.globl SYMNAME(io_pce_init)
SYMLABEL(io_pce_init)
	pushl %ebp
		
	mov 0x8(%esp), %ebp

	mov readmap, %edi

	mov $pce_r_bank_0, %eax
	call 0f
	mov $pce_r_bank_2, %eax
	call 0f
	mov $pce_r_bank_4, %eax
	call 0f
	mov $pce_r_bank_6, %eax
	call 0f
	mov $pce_r_bank_8, %eax
	call 0f
	mov $pce_r_bank_a, %eax
	call 0f
	mov $pce_r_bank_c, %eax
	call 0f
	mov $pce_r_bank_e, %eax
	call 0f
	mov $pce_r_zpage, %eax
	mov $0x100, %ecx
	repz
	stosl

	mov writemap, %edi

	mov $pce_w_bank_0, %eax
	call 0f
	mov $pce_w_bank_2, %eax
	call 0f
	mov $pce_w_bank_4, %eax
	call 0f
	mov $pce_w_bank_6, %eax
	call 0f
	mov $pce_w_bank_8, %eax
	call 0f
	mov $pce_w_bank_a, %eax
	call 0f
	mov $pce_w_bank_c, %eax
	call 0f
	mov $pce_w_bank_e, %eax
	call 0f
	mov $pce_w_zpage, %eax
	mov $0x100, %ecx
	repz
	stosl

	popl %ebp
	ret

0:	mov $0x2000, %ecx
	cld
	repz
	stosl
	ret

	
/* memory access routines */

	.globl pce_r_memzero
pce_r_memzero:
	movb $0x80, %al
	ret

	.globl pce_r_zpage
pce_r_zpage:
	pushl %edi
	movl page_0, %esi
	andl $0xff, %edi
	movb (%esi, %edi), %al
	popl %edi
	ret

	.globl pce_r_bank_0
pce_r_bank_0:
	pushl %edi
	movzbl mpr0, %esi
	cmpl $0xff, %esi
	jz pce_io_read1
	movl SYMNAME(pce_mmap)(,%esi,4), %esi
	andl $0x1fff, %edi
	movb (%esi, %edi), %al
	popl %edi
	ret

	.globl pce_r_bank_2
pce_r_bank_2:
	pushl %edi
	movzbl mpr1, %esi
	cmpl $0xff, %esi
	jz pce_io_read1
	movl SYMNAME(pce_mmap)(,%esi,4), %esi
	andl $0x1fff, %edi
	movb (%esi, %edi), %al
	popl %edi
	ret

	.globl pce_r_bank_4
pce_r_bank_4:
	pushl %edi
	movzbl mpr2, %esi
	cmpl $0xff, %esi
	jz pce_io_read1
	movl SYMNAME(pce_mmap)(,%esi,4), %esi
	andl $0x1fff, %edi
	movb (%esi, %edi), %al
	popl %edi
	ret

	.globl pce_r_bank_6
pce_r_bank_6:
	pushl %edi
	movzbl mpr3, %esi
	cmpl $0xff, %esi
	jz pce_io_read1
	movl SYMNAME(pce_mmap)(,%esi,4), %esi
	andl $0x1fff, %edi
	movb (%esi, %edi), %al
	popl %edi
	ret

	.globl pce_r_bank_8
pce_r_bank_8:
	pushl %edi
	movzbl mpr4, %esi
	cmpl $0xff, %esi
	jz pce_io_read1
	movl SYMNAME(pce_mmap)(,%esi,4), %esi
	andl $0x1fff, %edi
	movb (%esi, %edi), %al
	popl %edi
	ret

	.globl pce_r_bank_a
pce_r_bank_a:
	pushl %edi
	movzbl mpr5, %esi
	cmpl $0xff, %esi
	jz pce_io_read1
	movl SYMNAME(pce_mmap)(,%esi,4), %esi
	andl $0x1fff, %edi
	movb (%esi, %edi), %al
	popl %edi
	ret

	.globl pce_r_bank_c
pce_r_bank_c:
	pushl %edi
	movzbl mpr6, %esi
	cmpl $0xff, %esi
	jz pce_io_read1
	movl SYMNAME(pce_mmap)(,%esi,4), %esi
	andl $0x1fff, %edi
	movb (%esi, %edi), %al
	popl %edi
	ret

	.globl pce_r_bank_e
pce_r_bank_e:
	pushl %edi
	movzbl mpr7, %esi
	cmpl $0xff, %esi
	jz pce_io_read1
	movl SYMNAME(pce_mmap)(,%esi,4), %esi
	andl $0x1fff, %edi
	movb (%esi, %edi), %al
	popl %edi
	ret

	.globl pce_w_ignore
pce_w_ignore:	
	ret

	.globl pce_w_zpage
pce_w_zpage:
	pushl %edi
	movl page_0, %esi
	andl $0xff, %edi
	movb %al, (%esi, %edi)
	popl %edi
	ret

	.globl pce_w_bank_0
pce_w_bank_0:
	pushl %edi
	movzbl mpr0, %esi
	cmpl $0xff, %esi
	jz pce_io_write1
	movl SYMNAME(pce_mmap)(,%esi,4), %esi
	andl $0x1fff, %edi
	movb %al, (%esi, %edi)
	popl %edi
	ret

	.globl pce_w_bank_2
pce_w_bank_2:
	pushl %edi
	movzbl mpr1, %esi
	cmpl $0xff, %esi
	jz pce_io_write1
	movl SYMNAME(pce_mmap)(,%esi,4), %esi
	andl $0x1fff, %edi
	movb %al, (%esi, %edi)
	popl %edi
	ret

	.globl pce_w_bank_4
pce_w_bank_4:
	pushl %edi
	movzbl mpr2, %esi
	cmpl $0xff, %esi
	jz pce_io_write1
	movl SYMNAME(pce_mmap)(,%esi,4), %esi
	andl $0x1fff, %edi
	movb %al, (%esi, %edi)
	popl %edi
	ret

	.globl pce_w_bank_6
pce_w_bank_6:
	pushl %edi
	movzbl mpr3, %esi
	cmpl $0xff, %esi
	jz pce_io_write1
	movl SYMNAME(pce_mmap)(,%esi,4), %esi
	andl $0x1fff, %edi
	movb %al, (%esi, %edi)
	popl %edi
	ret

	.globl pce_w_bank_8
pce_w_bank_8:
	pushl %edi
	movzbl mpr4, %esi
	cmpl $0xff, %esi
	jz pce_io_write1
	movl SYMNAME(pce_mmap)(,%esi,4), %esi
	andl $0x1fff, %edi
	movb %al, (%esi, %edi)
	popl %edi
	ret

	.globl pce_w_bank_a
pce_w_bank_a:
	pushl %edi
	movzbl mpr5, %esi
	cmpl $0xff, %esi
	jz pce_io_write1
	movl SYMNAME(pce_mmap)(,%esi,4), %esi
	andl $0x1fff, %edi
	movb %al, (%esi, %edi)
	popl %edi
	ret

	.globl pce_w_bank_c
pce_w_bank_c:
	pushl %edi
	movzbl mpr6, %esi
	cmpl $0xff, %esi
	jz pce_io_write1
	movl SYMNAME(pce_mmap)(,%esi,4), %esi
	andl $0x1fff, %edi
	movb %al, (%esi, %edi)
	popl %edi
	ret

	.globl pce_w_bank_e
pce_w_bank_e:
	pushl %edi
	movzbl mpr7, %esi
	cmpl $0xff, %esi
	jz pce_io_write1
	movl SYMNAME(pce_mmap)(,%esi,4), %esi
	andl $0x1fff, %edi
	movb %al, (%esi, %edi)
	popl %edi
	ret

/* I/O emulation routines */
	
io_pce_rtbl1:
	.long 0x20
	.long 0x21
	.long 0x22
	.long 0x23
	.long 0x24
	.long 0x25
	.long 0x26
	.long 0x27

io_pce_read_msg:
	.ascii "PCE I/O read from 0x%04x\n\0"

	.globl pce_io_read1
pce_io_read1:
	pushal
	andl $0x1fff, %edi
	pushl %edi
	pushl $io_pce_read_msg
	call SYMNAME(printf)
	add $8, %esp
	popal
	popl %edi
	ret

	movl %edi, %esi
	andl $0x7, %esi
	jmp io_pce_rtbl1(,%esi,4)

io_pce_wtbl1:
	.long 0x10
	.long 0x11
	.long 0x12
	.long 0x13
	.long 0x14
	.long 0x15
	.long 0x16
	.long 0x17

io_pce_write_msg:
	.ascii "PCE I/O write 0x%02x to 0x%04x\n\0"

	.globl pce_io_write1
pce_io_write1:
	pushal
	andl $0x1fff, %edi
	pushl %edi
	andl $0xff, %eax
	pushl %eax
	pushl $io_pce_write_msg
	call SYMNAME(printf)
	add $12, %esp
	popal
	popl %edi
	ret

	movl %edi, %esi
	andl $0x7, %esi
	jmp io_pce_wtbl1(,%esi,4)

pce_io_devices_r:
	.long 0x20	/* $0000 - HuC6270 Video Display Controller */
	.long 0x21	/* $0400 - HuC6260 Video Color Encoder */
	.long 0x22	/* $0800 - PSG */
	.long 0x23	/* $0c00 - Timer */
	.long 0x24	/* $1000 - Joypad */
	.long 0x25	/* $1400 - IRQ controller */
	.long 0x26	/* $1800 - CDROM? */
	.long 0x27	/* $1c00 - Unknown */

pce_io_devices_w:
	.long 0x28	/* $0000 - HuC6270 Video Display Controller */
	.long 0x29	/* $0400 - HuC6260 Video Color Encoder */
	.long 0x2a	/* $0800 - PSG */
	.long 0x2b	/* $0c00 - Timer */
	.long 0x2c	/* $1000 - Joypad */
	.long 0x2d	/* $1400 - IRQ controller */
	.long 0x2e	/* $1800 - CDROM? */
	.long 0x2f	/* $1c00 - Unknown */

/*
 * $Log: io_pce.S,v $
 * Revision 1.6  1998/10/21 00:17:14  nyef
 * added preliminary tables for I/O dispatch. (completely nonfunctional)
 *
 * Revision 1.5  1998/07/29 01:13:42  nyef
 * added a bunch of SYMNAME/SYMLABELS for djgpp compatability.
 *
 * Revision 1.4  1998/07/26 23:18:31  nyef
 * added ZPage read/write code.
 *
 * Revision 1.3  1998/07/26 22:43:58  nyef
 * changed io handlers to display messeges saying what in going on instead
 *   of SIGSEGVing.
 *
 * Revision 1.2  1998/07/13 01:45:13  nyef
 * added memory read/write handlers
 *
 * Revision 1.1  1998/07/11 22:17:51  nyef
 * Initial revision
 *
 */
