/*
 * nes_blit.h
 *
 * typedefs and structures for the nes blit compiler.
 */

/* $Id: nes_blit.h,v 1.4 1998/08/15 15:20:53 nyef Exp $ */

#ifndef __NES_BLIT_H__
#define __NES_BLIT_H__

/*
 * usage:
 * nes_do_blit[pattern[0]](cur_vbp, colors, pattern[8]);
 */

typedef void (*blitfunc_t)(void * buffer, unsigned long colors, unsigned long pattern);

extern blitfunc_t nes_do_blit_80[0x02];
extern blitfunc_t nes_do_blit_c0[0x04];
extern blitfunc_t nes_do_blit_e0[0x08];
extern blitfunc_t nes_do_blit_f0[0x10];
extern blitfunc_t nes_do_blit_f8[0x20];
extern blitfunc_t nes_do_blit_fc[0x40];
extern blitfunc_t nes_do_blit_fe[0x80];
extern blitfunc_t nes_do_blit[0x100];
extern blitfunc_t nes_do_blit_7f[0x80];
extern blitfunc_t nes_do_blit_3f[0x40];
extern blitfunc_t nes_do_blit_1f[0x20];
extern blitfunc_t nes_do_blit_0f[0x10];
extern blitfunc_t nes_do_blit_07[0x08];
extern blitfunc_t nes_do_blit_03[0x04];
extern blitfunc_t nes_do_blit_01[0x02];

extern blitfunc_t nes_do_blit_rev_80[0x02];
extern blitfunc_t nes_do_blit_rev_c0[0x04];
extern blitfunc_t nes_do_blit_rev_e0[0x08];
extern blitfunc_t nes_do_blit_rev_f0[0x10];
extern blitfunc_t nes_do_blit_rev_f8[0x20];
extern blitfunc_t nes_do_blit_rev_fc[0x40];
extern blitfunc_t nes_do_blit_rev_fe[0x80];
extern blitfunc_t nes_do_blit_rev[0x100];
extern blitfunc_t nes_do_blit_rev_7f[0x80];
extern blitfunc_t nes_do_blit_rev_3f[0x40];
extern blitfunc_t nes_do_blit_rev_1f[0x20];
extern blitfunc_t nes_do_blit_rev_0f[0x10];
extern blitfunc_t nes_do_blit_rev_07[0x08];
extern blitfunc_t nes_do_blit_rev_03[0x04];
extern blitfunc_t nes_do_blit_rev_01[0x02];

void blit_init(void);

#endif /* __NES_BLIT_H__ */

/*
 * $Log: nes_blit.h,v $
 * Revision 1.4  1998/08/15 15:20:53  nyef
 * added blitters for reversed operation (sprites).
 *
 * Revision 1.3  1998/08/15 04:59:16  nyef
 * added blitters for clipped left-side operation.
 *
 * Revision 1.2  1998/08/15 04:15:01  nyef
 * added blitters for clipped right-side operation.
 *
 * Revision 1.1  1998/07/25 16:56:49  nyef
 * Initial revision
 *
 */
