/*
 * pce_vdp.h
 *
 * HuC6270/HuC6260 emulation.
 */

#ifndef PCE_VDP_H
#define PCE_VDP_H

/* $Id: pce_vdp.h,v 1.1 1999/01/17 02:12:51 nyef Exp $ */

typedef struct pce_vdp *pce_vdp;

typedef unsigned char (*portread_t)(pce_vdp);
typedef void (*portwrite_t)(pce_vdp, unsigned char);
typedef int (*periodic_t)(pce_vdp);

struct pce_vdp {
    portread_t readvdp0l;
    portread_t readvdp0h;
    portread_t readvdp1l;
    portread_t readvdp1h;
    portwrite_t writevdp0l;
    portwrite_t writevdp0h;
    portwrite_t writevdp1l;
    portwrite_t writevdp1h;
    portread_t readvce0l;
    portread_t readvce0h;
    portread_t readvce1l;
    portread_t readvce1h;
    portwrite_t writevce0l;
    portwrite_t writevce0h;
    portwrite_t writevce1l;
    portwrite_t writevce1h;
    periodic_t periodic;

    unsigned char flags;
    unsigned char status;
    unsigned char cur_reg;
    unsigned char *memory;
    unsigned short mem_read_addr;
    unsigned short mem_write_addr;
    unsigned char regs_l[32];
    unsigned char regs_h[32];
    unsigned char palette[32]; /* FIXME: not big enough */
    unsigned char palette_xlat[32];
    unsigned short cur_scanline;
};

pce_vdp pce_vdp_create(void);

#endif /* PCE_VDP_H */

/*
 * $Log: pce_vdp.h,v $
 * Revision 1.1  1999/01/17 02:12:51  nyef
 * Initial revision
 *
 */
