/*
 * sms9918.h
 *
 * sms custom vdp emulation.
 */

#ifndef SMS9918_H
#define SMS9918_H

/* $Id: sms9918.h,v 1.5 1999/01/11 02:24:35 nyef Exp $ */

typedef struct sms9918 *sms9918;

typedef unsigned char (*portread_t)(sms9918);
typedef void (*portwrite_t)(sms9918, unsigned char);
typedef int (*periodic_t)(sms9918);

struct sms9918 {
    portread_t readport0;
    portread_t readport1;
    portwrite_t writeport0;
    portwrite_t writeport1;
    portread_t readscanline;
    periodic_t periodic;

    unsigned char flags;
    unsigned char readahead;
    unsigned char addrsave;
    unsigned char status;
    unsigned char *memory;
    unsigned char regs[16];
    unsigned char palette[32];
    unsigned char palette_xlat[32];
    unsigned short address;
    unsigned short cur_scanline;
    unsigned char linecounter;
};

sms9918 sms9918_create(void);

#endif /* SMS9918_H */

/*
 * $Log: sms9918.h,v $
 * Revision 1.5  1999/01/11 02:24:35  nyef
 * added palette_xlat[] to struct sms9918 for new blitters.
 *
 * Revision 1.4  1999/01/10 00:02:01  nyef
 * fixed cur_scanline to be proper length.
 *
 * Revision 1.3  1999/01/09 23:10:00  nyef
 * added support for reading the current scanline.
 *
 * Revision 1.2  1999/01/08 02:24:43  nyef
 * added linecounter for line interrupts.
 *
 * Revision 1.1  1999/01/07 03:17:15  nyef
 * Initial revision
 *
 */
