/*
 * system.h
 *
 * definitions for system emulation control
 */

/* $Id: system.h,v 1.3 1999/01/01 06:27:13 nyef Exp $ */

#ifndef __SYSTEM_H__
#define __SYSTEM_H__

extern int system_type;

#define ST_NONE         0
#define ST_NES          1
#define ST_PCENGINE     2 /* also the CD versions */
#define ST_GENESIS      3
#define ST_MASTERSYS    4 /* also GameGear */
#define ST_GAMEBOY      5
#define ST_SNES         6
#define ST_LYNX         7
#define ST_JAGUAR       8
#define ST_SEGACD       9
#define ST_MACINTOSH   10 /* reserve through 19 for different versions */
#define ST_PLAYSTATION 20
#define ST_N64         21

void nes_run(int startup_deb);
void pce_run(int startup_deb);
void sms_run(int startup_deb);

#endif /* __SYSTEM_H__ */

/*
 * $Log: system.h,v $
 * Revision 1.3  1999/01/01 06:27:13  nyef
 * added prototype for sms_run().
 *
 * Revision 1.2  1998/07/26 14:20:06  nyef
 * added system defines for Master System, GameBoy, SNES, Lynx, Jaguar,
 *   SegaCD, Macintosh, Playstation and N64.
 *
 * Revision 1.1  1998/07/11 22:19:03  nyef
 * Initial revision
 *
 */
