/*
 * video_allegro.c
 *
 * display screen management
 */

/* $Id: video_allegro.c,v 1.6 1999/01/07 03:20:21 nyef Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <allegro.h>
#include "video.h"
#include "tool.h"

int video_active = 0;
int deblevel = 0;

BITMAP *nes_image;

typedef void ((*xlatfunc)(BITMAP *, char *));

vbpfunc video_get_vbp;
unsigned char *vbpfunc8(int line);
#if 0
xlatfunc vidxlate;
void vidxlate8  (BITMAP *dest, char *src);
#endif
/* void init_xlate8(void); */
unsigned char *vid_pre_xlat;
video_setpal_t video_setpal;
void init_xlate8(int colors, int *red, int *green, int *blue);

void video_init()
{
#ifdef GRAPHICS
    allegro_init();

    set_gfx_mode(GFX_VESA1, 640, 480, 640, 480);
    nes_image = create_bitmap(256, 240);
    video_setpal = init_xlate8;
/*     init_xlate8(); */

    install_keyboard();
#endif
}

void video_shutdown(void)
{
#ifdef GRAPHICS

#endif
}

void video_enter_deb(void)
{
#ifdef GRAPHICS
    if (video_active && (!deblevel)) {

    }
#endif
    deblevel++;
}

void video_leave_deb(void)
{
    deblevel--;
#ifdef GRAPHICS
    if (video_active && (!deblevel)) {

    }
#endif
}

void video_display_buffer()
{
#ifdef GRAPHICS
#if 0
    vidxlate(nes_image, video_buffer);
#endif
    blit(nes_image, screen, 0, 0, 192, 120, 256, 240);
#endif
}

extern long joy1_data;

void video_events(void)
{
#ifdef GRAPHICS

#if 0 /* this locks up the system. Oops. */
    if (key[KEY_F1]) {
	system_flags |= F_BREAK;
    } else {
	system_flags &= ~F_BREAK;
    }
#endif
    
    if (key[KEY_ESC]) {
	system_flags |= F_QUIT;
    } else {
	system_flags &= ~F_QUIT;
    }

    if (key[KEY_S]) {
	joy1_data |= 0x01;
    } else {
	joy1_data &= 0xfe;
    }
    
    if (key[KEY_A]) {
	joy1_data |= 0x02;
    } else {
	joy1_data &= 0xfd;
    }
    
    if (key[KEY_OPENBRACE]) {
	joy1_data |= 0x04;
    } else {
	joy1_data &= 0xfb;
    }
    
    if (key[KEY_CLOSEBRACE]) {
	joy1_data |= 0x08;
    } else {
	joy1_data &= 0xf7;
    }
    
    if (key[KEY_UP]) {
	joy1_data |= 0x10;
    } else {
	joy1_data &= 0xef;
    }
    
    if (key[KEY_DOWN]) {
	joy1_data |= 0x20;
    } else {
	joy1_data &= 0xdf;
    }
    
    if (key[KEY_LEFT]) {
	joy1_data |= 0x40;
    } else {
	joy1_data &= 0xbf;
    }
    
    if (key[KEY_RIGHT]) {
	joy1_data |= 0x80;
    } else {
	joy1_data &= 0x7f;
    }
#endif
}

#if 0
char *xlatepal;

void vidxlate8 (BITMAP *dest, char *src)
{
    int i;
    int j;

    for (i = 0; i < 240; i++) {
	for (j = 0; j < 256; j++) {
	    dest->line[i][j] = xlatepal[src[(i << 8) + j] & 0x3f];
	}
    }
}
#endif

unsigned char *vbpfunc8(int line)
{
    return nes_image->line[line];
}

#include "nespal.c"

void init_xlate8(int colors, int *red, int *green, int *blue)
{
    int i;
    RGB color;
    
    vid_pre_xlat = malloc(colors);
    video_get_vbp = vbpfunc8;
    
    for (i = 0; i < 64; i++) {
	color.r = red[i] >> 2;
	color.g = green[i] >> 2;
	color.b = blue[i] >> 2;
	set_color(i + 64, &color);
	vid_pre_xlat[i] = i + 64;
    }
}

/*
 * $Log: video_allegro.c,v $
 * Revision 1.6  1999/01/07 03:20:21  nyef
 * added in hacked up palette interface.
 *
 * Revision 1.5  1998/12/18 04:19:01  nyef
 * changed video driver from autodetect to vesa1.
 *
 * Revision 1.4  1998/10/02 03:29:54  nyef
 * fixed a few small problems that were preventing compilation.
 * nothing major, just stupid things.
 *
 * Revision 1.3  1998/09/02 01:45:01  nyef
 * updated to cover the new buffering scheme and ppu interface.
 *
 * Revision 1.2  1998/07/31 10:46:31  nyef
 * moved includes around a bit to squash EOF redefinition.
 *
 * Revision 1.1  1998/07/31 01:59:21  nyef
 * Initial revision
 *
 */
